# MATH introduce sets and set membership
(intro element);
(define element /
  ? x /
  ? lst /
  not /
  = (list-find-helper (lst) (x) (? y 0) 1) 0);
(element 8 (vector 8 4 3 0 5));
(element 5 (vector 8 4 3 0 5));
(element 0 (vector 8 4 3 0 5));
(element 1 (vector 1 0 3 9 5));
(element 3 (vector 1 0 3 9 5));
(element 0 (vector 1 0 3 9 5));
(element 5 (vector 6 8 1 0 2 5));
(element 1 (vector 6 8 1 0 2 5));
(element 5 (vector 6 8 1 0 2 5));
(element 6 (vector 6 8 3 9 2 5));
(element 6 (vector 6 8 3 9 2 5));
(element 5 (vector 6 8 3 9 2 5));
(element 4 (vector 6 4 1 7 2 5));
(element 1 (vector 6 4 1 7 2 5));
(element 7 (vector 6 4 1 7 2 5));
(not / element 6 (vector 8 3 7 9));
(not / element 6 (vector 8 4 1 3 5));
(not / element 6 (vector 9 2 5));
(not / element 0 (vector 7 2 5));
(not / element 6 (vector 3 5));
# rules for set equality
(define set-subset /
  ? x /
  ? y /
  if (> (list-length / x) 0)
   (and (element (head / x) (y))
        (set-subset (tail / x) (y)))
   (true));
(define set= /
  ? x /
  ? y /
  and (set-subset (x) (y)) (set-subset (y) (x)));
(set= (vector 1 5 9) (vector 5 1 9));
(set= (vector 1 5 9) (vector 9 1 5));
(not / set= (vector 1 5 9) (vector 1 5));
# let's go leave ourselves wide open to Russell's paradox
# ... by using characteristic functions
# ... since it doesn't really matter for communication purposes
# ... and so far this is just used / tested with sets of integers really
(element 5 (all (? x / = (+ (x) 10) 15)));
(element 3 (all (? x / = (* (x) 3) (+ (x) 6))));
(define empty-set / vector);
(element 0 (natural-set));
(forall
   (? x /
    => (element (x) (natural-set))
       (element (+ (x) 1) (natural-set))));
(element 1 (natural-set));
(element 2 (natural-set));
(element 3 (natural-set));
(element 4 (natural-set));
(element 5 (natural-set));
(element 6 (natural-set));
(element 7 (natural-set));
(element 8 (natural-set));
(element 9 (natural-set));
(define boolean-set / vector (true) (false));
(element (true) (boolean-set));
(element (false) (boolean-set));
# actually, to simplify semantics elsewhere, true and false
# are now just 0 and 1 so they are not distinct from ints
(define even-natural-set /
  all /
  ? x /
  exists /
  ? y /
  and (element (y) (natural-set))
      (= (* 2 (y)) (x)));
(element 0 (natural-set));
(element 0 (even-natural-set));
(element 1 (natural-set));
(not / element 1 (even-natural-set));
(element 2 (natural-set));
(element 2 (even-natural-set));
(element 3 (natural-set));
(not / element 3 (even-natural-set));
(element 4 (natural-set));
(element 4 (even-natural-set));
(element 5 (natural-set));
(not / element 5 (even-natural-set));
(element 6 (natural-set));
(element 6 (even-natural-set));
