# MATH introduce numbers (in unary notation)
# Here we count up, go through some primes, etc.
# There is some syntax around the numbers, but that doesn't
# need to be understood at this point.
# Any 'words' written here are converted to arbitrary integers
# in the actual message.  Any word ending in -in-unary will be given
# in unary rather than the binary code used in the main body
# of the message.
(intro-in-unary u1u);
(intro-in-unary u11u);
(intro-in-unary u111u);
(intro-in-unary u1111u);
(intro-in-unary u11111u);
(intro-in-unary u111111u);
(intro-in-unary u1111111u);
(intro-in-unary u11111111u);
(intro-in-unary u111111111u);
(intro-in-unary u1111111111u);
(intro-in-unary u11111111111u);
(intro-in-unary u111111111111u);
(intro-in-unary u1111111111111u);
(intro-in-unary u11111111111111u);
(intro-in-unary u111111111111111u);
(intro-in-unary u1111111111111111u);
(intro-in-unary u11u);
(intro-in-unary u111u);
(intro-in-unary u11111u);
(intro-in-unary u1111111u);
(intro-in-unary u11111111111u);
(intro-in-unary u1111111111111u);
(intro-in-unary u1u);
(intro-in-unary u1111u);
(intro-in-unary u111111111u);
(intro-in-unary u1111111111111111u);
# MATH introduce equality for unary numbers
# The intro operator does nothing essential, and could be
# omitted - it just tags the first use of a new operator.
# The = operator is introduced alongside a duplication of
# unary numbers.  The meaning will not quite by nailed down
# until we see other relational operators.
(=-in-unary u1u u1u);
(=-in-unary u11u u11u);
(=-in-unary u111u u111u);
(=-in-unary u1111u u1111u);
(=-in-unary u11111u u11111u);
(=-in-unary u111111u u111111u);
(=-in-unary u1111111u u1111111u);
(=-in-unary u11111111u u11111111u);
(=-in-unary u1u u1u);
(=-in-unary u111111u u111111u);
(=-in-unary u11u u11u);
# MATH now introduce other relational operators
# After this lesson, it should be clear what contexts
# < > and = are appropriate in.
# drive the lesson home
(=-in-unary u1u u1u);
(>-in-unary u11u u1u);
(>-in-unary u111u u1u);
(>-in-unary u1111u u1u);
(<-in-unary u1u u11u);
(=-in-unary u11u u11u);
(>-in-unary u111u u11u);
(>-in-unary u1111u u11u);
(<-in-unary u1u u111u);
(<-in-unary u11u u111u);
(=-in-unary u111u u111u);
(>-in-unary u1111u u111u);
(<-in-unary u1u u1111u);
(<-in-unary u11u u1111u);
(<-in-unary u111u u1111u);
(=-in-unary u1111u u1111u);
(>-in-unary u1u uu);
(>-in-unary u111111111u u11u);
(>-in-unary u111111u uu);
(>-in-unary u11u uu);
(>-in-unary u11111111u u11u);
(>-in-unary u1111u u1u);
(>-in-unary u11u uu);
(>-in-unary u1111111111u u1u);
(>-in-unary u111111u u1u);
(>-in-unary u111111111u u1u);
(>-in-unary u1111111u u1u);
(<-in-unary uu u1u);
(<-in-unary u111u u1111111111u);
(<-in-unary u1111u u111111111u);
(<-in-unary u11u u1111u);
(<-in-unary u1u u1111111u);
(<-in-unary uu u1111111111u);
(<-in-unary uu u11u);
(<-in-unary uu u11u);
(<-in-unary u1u u111u);
(<-in-unary u11u u11111u);
(<-in-unary u1u u1111u);
# switch to binary labelling for commands
(= u1u u1u);
(> u11u u1u);
(> u111u u1u);
(> u1111u u1u);
(< u1u u11u);
(= u11u u11u);
(> u111u u11u);
(> u1111u u11u);
(< u1u u111u);
(< u11u u111u);
(= u111u u111u);
(> u1111u u111u);
(< u1u u1111u);
(< u11u u1111u);
(< u111u u1111u);
(= u1111u u1111u);
# a few more random examples
(< u111u u1111u);
(= u1111u u1111u);
(< u1u u11111u);
(> u1111u uu);
(> u11111u u1111u);
(< u11u u111u);
(> u11u u1u);
(> u11111u u1u);
(= u111u u111u);
(= u111u u111u);
(> u1u uu);
